
;**********************************************************************
;	t@CFEk29Touch.asm			2020.06.07	  
;                                            jk1xkp
;**********************************************************************
;      Qlā@mV29FC.asm  /mV10Dsub.asm ;	mVFC.asm()PIC16F84A)	gp
;			ekT.asm()12F1822) 
;	ohb		PIC12F629   assembler ;MPLAB
;  gJE^@o
;
;		NbN	4MHz;

;sATCFidE̔z͏ȗj
;		( H:[qopen(LED̐ڑ̂݁j  L:[q4.7kGRDɗƂ)
;	PIC12F629	
;	sATC
;	GP0(07)				CW speed
;	GP1(06)				Dash
;	GP2(05)				Dot
;	GP3(04)				Bug Key
;	GP4(03)				Tone OUT
;	GP5(02)			=   Key Out
;**********************************************************************

	list      p=12f629           ; list directive to define processor
	#include <p12f629.inc>        ; processor specific variable definitions

	errorlevel  -302              ; suppress message 302 from list file

	__CONFIG   _CP_OFF & _CPD_OFF & _BODEN_ON & _MCLRE_OFF & _WDT_OFF & _PWRTE_ON &_INTRC_OSC_NOCLKOUT     

; '__CONFIG' directive is used to embed configuration word within .asm file.
; The lables following the directive are located in the respective .inc file.
; See data sheet for additional information on configuration word settings.
#define		Dsh   	Keych,1		;	GPIO,1		;;Dash
#define		Dtt   	Keych,2		;	GPIO,2		;;Dot
#define		Tone   	GPIO,4		;;Side Tone 820Hz
#define		Key		GPIO,5		;;Key Out

;***** VARIABLE DEFINITIONS
;    ------------- adress 20&H
w_temp        EQU     0x20        ; variable used for context saving 
status_temp   EQU     0x21        ; variable used for context saving
wait_cn		EQU	H'22'
wait_cn2	EQU	H'23'
cs			EQU	H'24'
cn			EQU	H'25'
wt_cn		EQU	H'26'	;Mark Space Time Base
wt_cn2		EQU	H'27'	;Mark Space Time Base
poi     	EQU	H'28'
aveT0		EQU	H'29'	;Dot key touch TMR1 count average
aveT1		EQU	H'2a'	;Dot
tripT		EQU	H'2b'	;Dot key tripl@1/16 x aveT
aveH0		EQU	H'2c'	;Dash key touch TMR1 count average
aveH1		EQU	H'2d'	;Dash 
tripH		EQU	H'2e'	;Dash key tripl@1/16 x aveH 
wait_AD_cn	EQU	H'2f'	;AD Convert̃^Cx[X
;    ------------- adress 30&H
x0       	EQU	H'30'	
x1      	EQU	H'31'
x2      	EQU	H'32'
x3  		EQU	H'33'
v0   		EQU	H'34'	;df[^
v1   		EQU	H'35'
v2   		EQU	H'36'
v3  		EQU	H'37'
y0  		EQU	H'38'
y1   		EQU	H'39'
y2   		EQU	H'3a'
y3  	  	EQU	H'3b'
val0		EQU	H'3c'		; ϊliRQrbgj
val1		EQU	H'3d'
val2		EQU	H'3e'
val3		EQU	H'3f'
;    ------------- adress 40&H
val_m		EQU	H'40'		; ꎞ]i[ꏊiTu[`Ŏgpj
dec0		EQU	H'41'	; 10ii[ꏊiPOoCgj address fix
dec1		EQU	H'42'
dec2		EQU	H'43'
dec3		EQU	H'44'
dec4		EQU	H'45'
dec5		EQU	H'46'
dec6		EQU	H'47'
dec7		EQU	H'48'
dec8		EQU	H'49'
dec9		EQU	H'4a'		;dec9 must be H'4C'
vfc			EQU	H'4b'	;B'00000+Dot+Dash' 1=ON, 0=Off
speed		EQU	H'4c'	;20<elekey speed<150 /when speed=50,Mark=50msec(WPM=10),
opt			EQU	H'4d'	;if opt.0=1 ,option_bun save mode
cwcode		EQU	H'4e'	;MORSEcode A=01000010b 2L(010b)  gc[i01j
length		EQU	H'4f'	;PMORSEcodeɊ܂܂钷_AZ_̍v;o
;    ------------- adress 50&H
pos			EQU	H'50'
sum			EQU	H'51'	;PMORSEcodeɊ܂܂钷_AZ_̍v;save
mk			EQU	H'52'	;codeodotmk=0,dashmk=1 Ƃ
N			EQU	H'53'	
d8			EQU	H'54'	;MORSEcodeL^			
ct			EQU	H'55'	
cu			EQU	H'56'	
Bugauto		EQU	H'57'	;if Bugauto.7=1, then dash dot auto. else normal Bug 
memo		EQU	H'58'	;momory for dot duirng dash or dash during dot
timespace	EQU	H'59'	;timespace=150 or 138 (Mark:space=100:92) 
Keych		EQU	H'5a'	;Keych ;if Dot(GP2), Keych.2=1 /if Dash(GP1), Keych.1=1
	
 
;    ------------- adress END H'5F'
;**********************************************************************
		ORG     0x000             ; processor reset vector
		goto    start              ; go to beginning of program

		ORG     0x004             ; interrupt vector location
		movwf   w_temp            ; save off current W register contents
		movf	STATUS,w          ; move status register into W register
		movwf	status_temp       ; save off contents of STATUS register


; isr code can go here or be located as a call subroutine elsewhere


		movf    status_temp,w     ; retrieve copy of STATUS register
		movwf	STATUS            ; restore pre-isr STATUS register contents
		swapf   w_temp,f
		swapf   w_temp,w          ; restore pre-isr W register contents
		retfie                    ; return from interrupt
; remaining code goes here
;----------------------------------------------------------------------------
;   ref p121 of CQ March 1998   JR7RAR Gꎁ̃ACfA
;			MORSEcode A=01000010b 2_\(010b)  gc[i01j
;			MORSEcode Q=11010100b 4_\(100b)  c[c[gc[i1101j
;
;Ql		retlw	57h	;poi=08h/letr=2eh;"."
;		retlw	H'95'	;poi=09h/letr=2fh;"/"
;		retlw	H'fd'	;poi=0ah/letr=30h;"0" 	letr͉t\̏ꍇ̃R[h
;		retlw	H'7d'	;poi=0bh/letr=31h;"1"  	Ekeył́Asgp
;		retlw	H'3d'	;poi=0ch/letr=32h;"2" 

;		retlw	H'1d'	;poi=0dh/letr=33h;"3" 
;		retlw	H'0d'	;poi=0eh/letr=34h;"4"
;		retlw	H'05'	;poi=0fh/letr=35h;"5"

;		retlw	H'85'	;poi=10h/letr=36h;"6" 
;		retlw	H'c5'	;poi=11h/letr=37h;"7"	
;		retlw	H'e5'	;poi=12h/letr=38h;"8" 

;		retlw	H'f5'	;poi=13h/letr=39h;"9"
;		retlw	H'06'	;poi=14h/letr=3ah;"HH=[:]ŕԂ"
;		retlw	H'7e'	;poi=15hletr=3bh;[;]
;		retlw	H'b5'	;poi=16h/letr=3ch;"<"

;		retlw	H'8d'	;poi=17h/letr=3dh;"="BT
;		retlw	H'b7'	;poi=18h/letr=3eh;">"
;		retlw	H'36'	;poi=19h/letr=3fh;"?"
;		retlw	H'17'	;poi=1ah/letr=40h;"VA"=[@]ŕԂ"
;		retlw	H'42'	;poi=1bh/letr=41h;"A"
;		retlw	H'84'	;poi=1ch/letr=42h;"B"
;		retlw	H'a4'	;poi=1dh/letr=43h;"C"	

;		retlw	83h	;poi=1eh/letr=44h;"D"
;		retlw	01h	;poi=1fh/letr=45h;"E"
;		retlw	24h	;poi=20h/letr=46h;"F"
			
;		retlw	H'c3'	;poi=21h/letr=47h;"G"
;		retlw	H'04'	;poi=22h/letr=48h;"H"
;		retlw	H'02'	;poi=23h/letr=49h;"I"

;		retlw	H'74'	;poi=24h/letr=4ah;"J"
;		retlw	H'a3'	;poi=25h/letr=4bh;"K"
;		retlw	H'44'	;poi=26h/letr=4ch;"L"

;		retlw	H'c2'	;poi=27h/letr=4dh;"M"
;		retlw	H'82'	;poi=28h/letr=4eh;"N"
;		retlw	H'e3'	;poi=29h/letr=4fh;"O"
	 		
;		retlw	H'64'	;poi=2ah/letr=50h;"P"
;		retlw	H'd4'	;poi=2bh/letr=51h;"Q"
;		retlw	H'43'	;poi=2ch/letr=52h;"R"
			
;		retlw	H'03'	;poi=2dh/letr=53h;"S"
;		retlw	H'81'	;poi=2eh/letr=54h;"T"
;		retlw	H'23'	;poi=2fh/letr=55h;"U"
					
;		retlw	H'14'	;poi=30h/letr=56h;"V"
;		retlw	H'63'	;poi=31h/letr=57h;"W"
;		retlw	H'94'	;poi=32h/letr=58h;"X"
		
;		retlw	H'b4'	;poi=33h/letr=59h;"Y"
;		retlw	H'c4'	;poi=34h/letr=5ah;"Z"
;		retlw	H'b5'	;poi=35h/letr=XX;"KN"
;		retlw	H'15'	;poi=36h/	;"VE"
;==========================
xkp_bun		addwf	PCL,1
		retlw	H'74'		;"J" pos=0;ctm;CusTaMise required!!
		retlw	H'a3'		;"K" pos=1;ctm
		retlw	H'7d'		;"1" pos=2;ctm
		retlw	H'94'		;"X" pos=3;ctm
		retlw	H'a3'		;"K" pos=4;ctm
		retlw	H'64'		;"P" pos=5;ctm
		retlw	H'00'		;"_" pos=6
		retlw	H'ff'		;END pos=7  0ffh ōŌ𔻒f
		nop

Dot_bun	addwf	PCL,1
		retlw	H'83'		;"D" pos=0;
		retlw	H'e3'		;"O" pos=1;
		retlw	H'81'		;"T" pos=1;
		retlw	H'ff'		;END pos=7  0ffh ōŌ𔻒f
		nop

Dash_bun	addwf	PCL,1
		retlw	H'83'		;"D" pos=0;
		retlw	H'42'		;"A" pos=1;
		retlw	H'03'		;"S" pos=0;
		retlw	H'04'		;"H" pos=1;
		retlw	H'ff'		;END pos=7  0ffh ōŌ𔻒f
		nop


;=========
Dig_CW	addwf	PCL,1
		retlw	H'fd'		;"0" pos=0;ctm;CusTaMise required!!
		retlw	H'7d'		;"1" pos=1;ctm
		retlw	H'3d'		;"2" pos=2;ctm
		retlw	H'1d'		;"3" pos=3;ctm
		retlw	H'0d'		;"4" pos=4;ctm
		retlw	H'05'		;"5" pos=5;ctm
		retlw	H'85'		;"6" pos=6
		retlw	H'c5'		;"7" pos=7;ctm
		retlw	H'e5'		;"8" pos=8;ctm
		retlw	H'f5'		;"9" pos=9;ctm
		retlw	H'01'	       ;10 "E"
		retlw	H'01'	       ;11 "E"
		retlw	H'01'	       ;12 "E"
		retlw	H'01'	       ;13 "E"
		retlw	H'01'	       ;14 "E"
		retlw	H'01'	       ;15 "E"
		retlw	H'01'	       ;16 "E"
		nop

;---------------------------------------------------
setDot		;Dot
		bcf		T1CON,0	;TMR1 Enable stop bit 
		movf	TMR1H,0
		movwf	aveT1
		movwf	x1
		movf	TMR1L,0
		movwf	aveT0
		movwf	x0
		bcf		STATUS,C
		rrf		x1,1			;x=1/2 x x
		rrf		x0,1
		bcf		STATUS,C
		rrf		x1,1			;x=1/4 x x
		rrf		x0,1
		bcf		STATUS,C
		rrf		x1,1			;x=1/8 x x
		rrf		x0,1
		bcf		STATUS,C
		rrf		x1,1			;x=1/16 x x
		rrf		x0,1
		movf	x0,0
		movwf	tripT
		return

;----------
beepH	movlw	D'10'	;	mov	cn,#10
		movwf	cn
bpH2	bsf		Tone		;Beep 2400Hz
		nop
		nop
		nop
		nop
		nop
		bcf		Tone		
		nop
		nop
		nop
		nop		
		decfsz	cn,1	;djnz	cn,bpH2
		goto	bpH2
		return

bspace		movlw	D'20'	;	mov	cn,#20
			movwf	cn
bspace0		movlw	D'1'	;mov	wait_cn,#1
			movwf	wt_cn
			call 	wait_us	
			decfsz	cn,1	;	djnz	cn,bspace0
			goto	bspace0
			return

;--------------------------------------------------

;  ----------------------------------------------
start	call    0x3FF             ; retrieve factory calibration value
		bsf     STATUS,RP0        ; set file register bank to 1
		movwf   OSCCAL            ; update register with factory cal value 
		bcf     STATUS,RP0        ; set file register bank to 0

		call	wait_255

 		clrf	GPIO
		movlw	B'00000111'		;Rp[^[ɂB@GPIODigital I/O
		movwf	CMCON

		movlw	B'00000000'		;
		movwf	INTCON

		bsf    	STATUS,RP0	;oN1
		movlw	B'00000000'		;GIOvAbvEnable; ;TMR0 prescaler 1:2 set ;	
		movwf	OPTION_REG	

		movlw	B'00001111'		 ;GPIO 5,4-Output ,3-1;input
		movwf	TRISIO

	;	movlw	B'00110110'		;NormalKey /GP4,5 EB[NEvAbv  GP0,1,2= enable
		movlw	B'00110000'		;touchkey /GP4-1 EB[NEvAbv  GP0,1,2= disable
		movwf	WPU
		bcf    	STATUS,RP0	;oN0
		clrf	GPIO

		movlw	B'00000001'	; TMR1 IntOSC clock/ PSA=1:1
		movwf	T1CON 

		clrf	vfc

		movlw	D'20'	
		movwf	speed
		bcf		speed,0		;markŏɁ@bsf Tone(800Hz) M邽

		movlw	B'00000110'	;HH	;dash (RA1)=H & dot(RA2)=H
		movwf	memo		;HH

		movlw	B'10000000'		;Bug key auto
		btfss	GPIO,3			;Bug key auto
		movlw	B'00000000'		;Bug key auto //;if Bugauto.7=1, then dash dot auto, else.7=0 Bugkey
		movwf	Bugauto			;Bug key auto

		movlw	D'150'
	;	btfss	PORTB,0
		movlw	D'138'
		movwf	timespace

s12		call	xkp		; call sign o

		bsf		STATUS,5	;oN1	
		bcf		TRISIO,2	;GP2(Dot)  Output
		bcf		TRISIO,1	;GP1(Dash) Output
		bcf		STATUS,5	;oN0	
		bsf		GPIO,2		;Capacity +5V charge
		bsf		GPIO,1		;Capacity +5V charge
		call	wait_20		;[d@20msec
s2		movlw	B'11111111'
		movwf	Keych		

		bcf		INTCON,GIE
;------------
	;	movlw 	H'd4'			;aveT=54321
	;	movwf	aveT1
	;	movlw 	H'31'
	;	movwf	aveT0

Test	nop		;gP1,GP2VL=0.8VɒB鎞Ԃ@CW codeœǂݏoTESTvO@
				;TMR0=Fosc/4=1,000,000Hz PSA=2Ȃ̂Ł@5000,000Hz// 1 count/2 usec
				;Dash key̏ꍇ́ATMR0 ˁ@AVT0
				; Dot Key̏ꍇ́ATMR0 ˁ@AVH0
				;Keych ;if Dot(GP2), Keych,2=0 /if Dash(GP1), Keych,1=0
;======================		
; ---------------------------------
Ekey	bsf		Tone
		bsf    	STATUS,RP0	;oN1	
		bsf		TRISIO,4		;GP4, output  input//PTT̊mF
		bcf    	STATUS,RP0	;oN0
		
		btfss	GPIO,4	;if RA4=L, then goto PTT
		goto	PTT

		bsf    	STATUS,RP0	;oN1
		bcf		TRISIO,4	;ra4, input  output//ʏKey
		bcf    	STATUS,RP0	;oN0
		bsf		Tone
;--------------------
dot0	;	clrf	sum		;option ݂̐ݒ
		;	clrf	d8		;option ݂̐ݒ

		call	KeyDD
		btfss	Dtt		;if rb.5=L,then dot
		goto	dot

dot01	call	KeyDD
		btfss	Dsh		;if rb.4=L,then dash
		goto	dash
		goto	Ekey

dot		nop
		movlw	B'00000110'	;HH	;dash (RA1)=H & dot(RA2)=H
		movwf	memo		;HH

		call	mark4
	;==@memo reset From here, dot memory==== 	
		movlw	B'00000110'	;HH	;dash (RA1)=H & dot(RA2)=H
		movwf	memo		;HH
	;======================= dot memory==== 

dt5		call	space2
		call	space2

		btfss	memo,1		;HH if RA1=L (memory of dash),goto dash
		goto	dash		;HH

dot_a	call	KeyDD
		btfss	Dsh		;if rb.4=L,then dash
		goto	dash
		btfss	Dtt		;if rb.5=L,then dot
		goto	dot
		
dot1	call	space2

		call	KeyDD
		btfss	Dsh		;if rb.4=L,then dash
		goto	dash
		btfss	Dtt		;if rb.5=L,then dot;
		goto	dot
		
		call	space4
		call	space2

dotend	goto	Ekey

dash	movlw	B'00000110'	;HH	;dash (RA1)=H & dot(RA2)=H
		movwf	memo		;HH
		
		btfsc	GPIO,3		;Bug key
		goto	dash1		;Bug key
	;---
		btfss	Bugauto,7	;;if Bugauto.7=1, then dash dot auto./B1
		goto	B9	
	;---
							;dot=100, space=100, dash=300
B1		clrf	cs			;Bug key-auto	;mark count 1 for 1*mark
		bsf		Key		;Bug key-auto
		call	Bmark1		;Bug key-auto

		;@Z_;;;;
		movf	cs,1		;Bug key-auto	;if cs=0	(0-25)
		btfsc	STATUS,Z	;Bug key-auto
		goto	B20			;Bug key-auto

		movlw	D'1'		;Bug key-auto	;if cs=1	(25-50)
		subwf	cs,0		;Bug key-auto	W=cs +(256-1)
		btfsc	STATUS,Z	;Bug key-auto	if cs=1, goto B2=dot
		goto	B21

		movlw	D'2'		;Bug key-auto	;if cs=2	(50-75)
		subwf	cs,0		;Bug key-auto	W=cs +(256-1)
		btfsc	STATUS,Z	;Bug key-auto	if cs=1, goto B2=dot
		goto	B22

		movlw	D'3'		;Bug key-auto	;if cs=3	(75-100)
		subwf	cs,0		;Bug key-auto	W=cs +(256-1)
		btfsc	STATUS,Z	;Bug key-auto	if cs=1, goto B2=dot
		goto	B23
		; ܂ŒZ_G

			;;璷_;;
		movlw	D'8'		;Bug key-auto	;if cs=8	(200-225)
		subwf	cs,0		;Bug key-auto	W=cs +(256-1)
		btfsc	STATUS,Z	;Bug key-auto	if cs=1, goto B2=dot
		goto	B40	

		movlw	D'9'		;Bug key-auto	;if cs=9	(225-250)
		subwf	cs,0		;Bug key-auto	W=cs +(256-1)
		btfsc	STATUS,Z	;Bug key-auto	if cs=1, goto B2=dot
		goto	B41

		movlw	D'10'		;Bug key-auto	;if cs=10	(250-275)
		subwf	cs,0		;Bug key-auto	W=cs +(256-1)
		btfsc	STATUS,Z	;Bug key-auto	if cs=1, goto B2=dot
		goto	B42

		movlw	D'11'		;Bug key-auto	;if cs=11	(275-300)
		subwf	cs,0		;Bug key-auto	W=cs +(256-1)
		btfsc	STATUS,Z	;Bug key-auto	if cs=1, goto B2=dot
		goto	B43	
		goto	B6			;Bug key-auto@Other@cs than 0,1,2,3,  8,9,10,11
			;;܂Œ_GG
		;-----
		;-----
B20		call	wtm1		;Bug key-auto	;cs=0 remaining period
		call	mark3		;Bug key-auto	(75)
		goto	B6		;Bug key-auto

B21		call	wtm1		;Bug key-auto	;cs=1 remaining period
		call	mark2		;Bug key-auto	(50)		
		goto	B6		;Bug key-auto	

B22		call	wtm1		;Bug key-auto	;cs=1 remaining period
		call	mark1		;Bug key-auto	(25)
		goto	B6		;Bug key-auto

B23		call	wtm1		;Bug key-auto	;cs=1 remaining period
		goto	B6		;Bug key-auto

B40		call	wtm1		;Bug key-auto	;cs=4 remaining period
		call	mark3		;Bug key-auto	(75)
		goto	B6		;Bug key-auto

B41		call	wtm1		;Bug key-auto	;cs=4 remaining period
		call	mark2		;Bug key-auto	(50)
		goto	B6		;Bug key-auto

B42		call	wtm1		;Bug key-auto	;cs=4 remaining period
		call	mark1		;Bug key-auto	(25)
		goto	B6		;Bug key-auto

B43		call	wtm1		;Bug key-auto	;cs=4 remaining period
		goto	B6		;Bug key-auto

B6		call	space1		;Ȃ(25)
		goto	dash2		;Bug key-auto	;
	;----------------------
B9		bsf		Key		;Bug key
dashB	movlw	D'1'		;Bug key
		movwf	wt_cn			;Bug key
		call	wtm1		;Bug key
		call	KeyDD		
		btfss	Dsh		;Bug key
		goto	dashB		;Bug key
		bcf		Key		;Bug key
		bcf		Key		;Bug key
		goto	dash2		;Bug key

dash1	call	mark8
	;==@memo reset From here, dot memory==== 	
		movlw	B'00000110'	;HH	;dash (RA1)=H & dot(RA2)=H
		movwf	memo		;HH
	;======================= dot memory==== 
		call	mark2	
		call	mark2

dash2	call	space4		;(100)

		btfss	memo,2		; if RA2=L (memory of dot),goto dot
		goto	dot		;
		
		call	KeyDD
		btfss	Dtt		;if rb.5=L,then goto dash3 (dot)
		goto	dash3
		btfss	Dsh		;if rb.4=L,then dash 
		goto	dash

		goto	dot_a

dash3	goto	dot

;--------------------
space14		call	space6		;if 7*space, then space6+8
space8		call	space2		; space2+6
space6		call	space1		; space1+1+4
			call	space1
space4		call	space1		; space1+1+2
			call	space1
space2		call	space1		;if space, then space2
space1		bcf		Key
			bsf		Tone
			call	spdch		;speed `FbN;R=10k{C=1000pF̎萔check
			movf	speed,0			;mov	wait_cn,speed
			movwf	wt_cn	
			call	wait_sp		;HH;Time='speed 'msec
			return
;-------------------
mark8		call	mark2	
mark6		call	mark2		;if dash, then mark6
mark4		call	mark1		;if dash, then mark4+mark2
mark3		call	mark1
mark2		call	mark1		;if dot, then mark2
mark1		bsf		Key
			bsf		Tone
		;	call	spdch		;speed `FbN;R=10k{C=1000pF̎萔check
			movf	speed,0		;mov	wait_cn,speed	
			movwf	wt_cn
			call	wait_mk
			return
;-----------------------------
wait_sp		 ;150 * (1+3) *2=1200sec	;HH
		;		movf	GPIO,0
			call	KeyDD
			movf	Keych,0			
			andlw	B'00000110'		
			andwf	memo,1		;memory of dash or dot 

wts1		nop		;800Hz Tone
	;		;movlw	D'138'			;mov	wait_cn2,#250	;-------- --------- 
			movf	timespace,0		;timespace=150 or 138 (Mark:space=100:92) 
			movwf	wt_cn2    
					;	| 	|    
wts2		nop					;1  (1msec)	|
					;	|	|
			decfsz	wt_cn2,1	;1	;djnz	wait_cn2,wtm2	;3------- 	|
			goto	wts2		;2

			decfsz	wt_cn,1			;djnz	wait_cn,wtm1   	;	   	|
			goto	wts1
			nop
			return			;	  -----------	

;-------------------------
wait_mk		 ;150 * (1+3) *2=1200sec	;HH
	;			movf	GPIO,0
			call	KeyDD
			movf	Keych,0			
			andlw	B'00000110'		
			andwf	memo,1		;memory of dash or dot 

wtm1		movf	wt_cn,1		;Bug key auto TRAP
			btfsc	STATUS,Z
			return

			bsf		Tone
			btfsc	wt_cn,0
			bcf		Tone		;800Hz Tone
			movlw	D'150'			;;-------- --------- 
			movwf	wt_cn2    
									;;	| 	|    
wtm2		nop						;;1  (1msec)	|
			decfsz	wt_cn2,1		;;2	
			goto	wtm2			;;2 ;;5 x150=750usec------- 	|
									;;	("speed" msec)
			decfsz	wt_cn,1		;;		;	   	|
			goto	wtm1
			bsf		Tone
			return			;	  -----------	

;======--Bug key auto	wait_mk
Bmark1		bsf		Tone
		;	call	spdch		;speed `FbN;R=10k{C=1000pF̎萔check
			movf	speed,0		;mov	wait_cn,speed	
			movwf	wt_cn
;-------------
Bwait_mk		 ;150 * (1+3) *2=1200sec	;HH
	;				movf	GPIO,0
			call	KeyDD
			movf	Keych,0			
			andlw	B'00000110'		
			andwf	memo,1		;memory of dash or dot 

Bwtm1		bsf		Tone
			btfss	wt_cn,0
			bcf		Tone		;800Hz Tone

			movlw	D'150'			;;-------- --------- 
			movwf	wt_cn2    
									;;	| 	|    
Bwtm2		nop						;;1  (1msec)	|
									;;	|	|
			decfsz	wt_cn2,1		;;1	;;3------- 	|
			goto	Bwtm2			;;2
									;;	("speed" msec)
			call	KeyDD
			btfsc	Dsh		;if dash key OFF, then return
			return

			decfsz	wt_cn,1		;;		;	   	|
			goto	Bwtm1
			bsf		Tone
			incf	cs,1
			goto	Bmark1	

			;return			;	  -----------
;------------- RA4@1kŐڒnƂ́ADash keyPTT@ƂȂ
PTT		bsf		Tone
		bsf    	STATUS,RP0	;oN1
		bcf		TRISIO,4	;ra4, input  output//KeyOnłԂ
		bcf    	STATUS,RP0	;oN0

PT5		call	KeyDD
		btfss	Dsh
		goto	PTon
		goto	PToff

PTon	bsf		Key
		call	wait_20  ;wait 20msec
		call	KeyDD
		btfss	Dsh
		goto	PTon

PToff	bcf		Key
		goto	Ekey
	
;-----------------
spdch	goto	Dspdch			;720usec
	;	movlw	D'25'	
	;	movwf	speed
	;	bcf		speed,0		;markŏɁ@Tone(800Hz)M邽
	;	return
Dspdch
;===========; Fosc=4MHz/4 PSA=2Ł@TMR0Ŏ󂯂āAC+5Vŏ[dAGP0=L<0.8V@ɂȂ܂ł̎(40usec) 		
		bcf		INTCON,2	;clr TOIF
		bcf		STATUS,5	;oN0		
		clrf	TMR0		;TMR0NA
		bsf		STATUS,5	;oN1	
		clrwdt		
		bsf		TRISIO,0	;;GPIO GP0Input
		bcf		STATUS,5	;oN0
		
Dspd2	btfsc	INTCON,2	;2 step;---if overflow, goto spd3			
		goto	Dspd3		;0	|
					;	| 1Loop=5step	
		btfsc	GPIO,0		;1step	|	
		goto	Dspd2		;2step------
		movf	TMR0,0		;W TRM0
		goto	Dspd4			
						
Dspd3	movlw	D'150'		
Dspd4	movwf	speed
		bcf		speed,0

		bsf		STATUS,5	;oN1	
		bcf		TRISIO,0	;GP0 Output
		bcf		STATUS,5	;oN0	
		bsf		GPIO,0		;Capacity +5V charge
		call	wait_50uS
		return
;=============

Uspdch		; routine ͎gĂȂ
;===========; Fosc=4MHz/4 PSA=2Ł@TMR0Ŏ󂯂āAGP0=H0.8V@ɂȂ܂ł̎(40usec) 		
		bcf		INTCON,2	;clr TOIF
		bcf		STATUS,5	;oN0		
		clrf	TMR0		;TMR0NA
		bsf		STATUS,5	;oN1	
		clrwdt		
		bsf		TRISIO,0	;;GPIO GP0Input
		bcf		STATUS,5	;oN0
		
Uspd2	btfsc	INTCON,2	;2 step;---if overflow, goto spd3			
		goto	Uspd3		;0	|
					;	| 1Loop=5step	
		btfss	GPIO,0		;1step	|	
		goto	Uspd2		;2step------
		movf	TMR0,0		;W TRM0
		goto	Uspd4			
						
Uspd3	movlw	D'150'		
Uspd4	movwf	speed
		bcf		speed,0

		bsf		STATUS,5	;oN1	
		bcf		TRISIO,0	;GP0 Output
		bcf		STATUS,5	;oN0	
		bcf		GPIO,0		;Capacity GND Discharge
		call	wait_50uS
		return
;=============
;===========-Key ON/OFF?? Sub routein======
KeyDD	goto	Tspeed		;;Keych ;if Dot(GP2), Keych,2=0 /if Dash(GP1), Keych,1=0

		;temp  temṕA@Normal@Elekey ƂƂɎgB@mFρB
		bsf		STATUS,5	;oN1	
		bsf		TRISIO,1		;GP1(Dash) input
		bsf		TRISIO,2		;GP2(Dot) input
		bcf		STATUS,5	;oN0
		nop
		movf	GPIO,0
		movwf	Keych
		return
		;temp

Tspeed	;Dot(GP2)==; Fosc=4MHz/4 PSA=2Ł@TMR0Ŏ󂯂āAGP0=L<1.2V@ɂȂ܂ł̎(40usec) 	
		bsf		STATUS,5	;oN1
		bcf		TRISIO,2	;;GPIO GP2Output
		bcf		STATUS,5	;oN0
		bcf		GPIO,2		;Capacity + Discharge
		call	wait_50uS

		bcf		INTCON,2	;clr TOIF
		clrf	TMR0		;TMR0NA

		bsf		STATUS,5	;oN1	
		clrwdt
		bcf		TRISIO,2	;GP2 Output
		bcf		STATUS,5	;oN0	
		bsf		GPIO,2		;Capacity +5V charge
		call	wait_50uS

		bsf		STATUS,5	;oN1		
		bsf		TRISIO,2	;;GPIO GP2Input
		bcf		STATUS,5	;oN0
		
Tspd2	btfsc	INTCON,2	;2 step;---if overflow, goto spd3			
		goto	Tspd3		;0	|
					;	| 1Loop=5step	
		btfsc	GPIO,2		;1step	|	
		goto	Tspd2		;2step------
		movf	TMR0,0		;W TRM0
		goto	Tspd4			
						
Tspd3	movlw	D'255'		
Tspd4	movwf	aveT0

		movlw	D'100'
		subwf	aveT0,0		;W=aveT0 +(256-W)
		bsf		Keych,2
		btfsc	STATUS,C
		bcf		Keych,2

;=============Dash(GP1)==; 
Hspeed	bsf		STATUS,5	;oN1
		bcf		TRISIO,1	;;GPIO GP1Output		
		bcf		STATUS,5	;oN0
		bcf		GPIO,1		;Capacity + Discharge
		call	wait_50uS

		bcf		INTCON,2	;clr TOIF
		clrf	TMR0		;TMR0NA
		bsf		STATUS,5	;oN1	
		clrwdt
		bcf		TRISIO,1	;GP1 Output
		bcf		STATUS,5	;oN0	
		bsf		GPIO,1		;Capacity +5V charge
		call	wait_50uS

		bsf		STATUS,5	;oN1		
		bsf		TRISIO,1	;;GPIO GP1Input
		bcf		STATUS,5	;oN0
		
Hspd2	btfsc	INTCON,2	;2 step;---if overflow, goto spd3			
		goto	Hspd3		;0	|
					;	| 1Loop=5step	
		btfsc	GPIO,1		;1step	|	
		goto	Hspd2		;2step------
		movf	TMR0,0		;W TRM0
		goto	Hspd4			
						
Hspd3	movlw	D'255'		
Hspd4	movwf	aveH0

		movlw	D'100'
		subwf	aveH0,0		;W=aveH0 +(256-W)
		bsf		Keych,1
		btfsc	STATUS,C
		bcf		Keych,1

		return
;==============
;----------------------------------------------------
dt_5	movlw	H'5'	;mov  	code,#05h
		movwf	cwcode
		call	trans
		return	
;----------------------------------------------------
;--------------------------------------------------
xkp		clrf	pos		;JK1XKP_ o
xkp1	movf	pos,0
		call	xkp_bun
		movwf	cwcode

		sublw	H'ff'
		btfsc	STATUS,Z
		goto	xkp3

		call	trans
		incf	pos,1
		goto	xkp1

xkp3	return
;-----------------------------------
trans	movf	cwcode,0
		andlw	B'00000111'
		movwf	length

		movf	cwcode,0
		andlw	B'11111000'
		movwf	cwcode

		movlw	D'0'			;cse	length,#0
		subwf	length,0
		btfss	STATUS,Z
		goto	trans0
		call	spce28		
		return
trans0	rlf		cwcode,1
		btfsc	STATUS,C
		bsf		mk,0
		btfss	STATUS,C
		bcf		mk,0

		btfsc	mk,0
		call	mrk12
		btfss	mk,0
		call	mrk4
		call    spce4
		decfsz	length,1			;djnz	length,trans0
		goto	trans0
		call	spce12
		return

;-----------------------------------

spce28	call	spce14
spce14	call	spce1		;2003.6.23 C
		call	spce1
spce12	call	spce4
spce8	call	spce2
spce6	call	spce2
spce4	call	spce1
		call	spce1
spce2	call	spce1
spce1	bcf		Key
		bsf		Tone
		call	spdch		;speed `FbN;R=10k{C=1000pF̎萔check		
		movf	speed,0			;mov	wait_cn,speed
		movwf	wt_cn	
		call	wait_sp2
		return
;-------------------

mrk12	call	mrk4
mrk8	call	mrk2
mrk6	call	mrk2
mrk4	call	mrk1
mrk3	call	mrk1
mrk2	call	mrk1
mrk1	;bsf		Key
		bsf		Tone
		call	spdch		;speed `FbN;R=10k{C=100pF̎萔check
		movf	speed,0	;	mov	wait_cn,speed
		movwf	wt_cn	
		call	wait_mk2
		return
;-----------------------------
wait_mk2	
wtm20	nop	     	;75 * (2+2+1+3) *2 =1200 sec
wtm21	bsf		Tone
		btfsc	wt_cn,0
		bcf		Tone		;800Hz Tone

		movlw	D'150'	;mov	wait_cn2,#125	;-------- ---------  
		movwf	wt_cn2  
							;	| 	|    
wtm22	nop					;1  (1msec)	|
		decfsz	wt_cn2,1	;1	;djnz	,wtm22	;3------- 	|
		goto	wtm22		;2

	;	btfss	Dsh		;2	| 	| key ω?
	;	return				;0	| 	|
	;	btfss	Dtt		;2	| 	| key ω?
	;	return				;0	| 	|

		decfsz	wt_cn,1			;djnz	wait_cn,wtm21   	;	   	|
		goto	wtm21
		bsf		Tone
		return	
	;--------------------
wait_sp2
wts20		     	;75 * (2+2+1+3) *2 =1200 sec
		nop
wts21	nop	;800Hz Tone	

		movlw	D'150'	;mov	wait_cn2,#125	;-------- ---------  
		movwf	wt_cn2  
							;	| 	|    
wts22	nop					;1  (1msec)	|
		decfsz	wt_cn2,1	;1	;djnz	,wtm22	;3------- 	|
		goto	wts22		;2

	;	btfss	Dsh		;2	| 	| key ω?
	;	return				;0	| 	|
	;	btfss	Dtt		;2	| 	| key ω?
	;	return				;0	| 	|

		decfsz	wt_cn,1			;djnz	wait_cn,wtm21   	;	   	|
		goto	wts21
		return
;--------------------

;---------------------------------------------------------------------------------
;		I[_[̃EFCg
;
wait_255	movlw	D'255'			;mov	wait_cn,#255
			movwf	wait_cn
			goto	wait_ms

wait_20		movlw	D'20'			;mov	wait_cn,#20
			movwf	wait_cn
wait_ms  
		
wait_ms0
			movlw	D'0'			;mov	wait_cn2,#0
			movwf	wait_cn2
wait_ms1
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		decfsz	wait_cn2,1				;djnz	wait_cn2,wait_ms1
		goto	wait_ms1
		decfsz	wait_cn,1				;djnz	wait_cn,wait_ms0
		goto	wait_ms0
		return

;
;		ʂI[_[̃EFCg
wait_20uS	movlw	D'20'			;mov	wait_cn,#20
			movwf	wait_cn
			goto	wait_us

wait_50uS	movlw	D'50'			;mov	wait_cn,#50
			movwf	wait_cn
			goto	wait_us

wait_100uS	movlw	D'100'			;mov	wait_cn,#100
			movwf	wait_cn
			goto	wait_us
;
wait_us
wait_us0
		decfsz	wait_cn,1			;djnz	wait_cn,wait_us0
		goto	wait_us0
		return
; ------- AD Coñ^Cx[X-------
wait_AD
wait_AD0
		decfsz	wait_AD_cn,1			;djnz	wait_cn,wait_us0
		goto	wait_AD0
		return

;---------------------------------------------------------	
;	Z		(32bit)(32bit)|y(32bit)@
;
sub_xy
		movf	y0,0		;sub	x[0],y[0]
		subwf	x0,1
		movlw	D'1'
		btfss	STATUS,C
		subwf	x1,1
		btfss	STATUS,C
		subwf	x2,1
		btfss	STATUS,C
		subwf	x3,1
		
		movf	y1,0		;sub	x[1],y[1]
		subwf	x1,1
		movlw	D'1'
		btfss	STATUS,C
		subwf	x2,1
		btfss	STATUS,C
		subwf	x3,1

		movf	y2,0		;sub	x[2],y[2]
		subwf	x2,1
		movlw	D'1'
		btfss	STATUS,C
		subwf	x3,1
		
		movf	y3,0		;sub	x[3],y[3]
		subwf	x3,1
		return
;--------------------------------------------------------------------
; 	Z	(32bit)(32bit){y(32bit)@
;
add_xy				
		movf	y0,0		;add	x[0],y[0]
		addwf	x0,1
		movlw	D'1'
		btfsc	STATUS,C
		addwf	x1,1
		btfsc	STATUS,C
		addwf	x2,1
		btfsc	STATUS,C
		addwf	x3,1
		
		movf	y1,0		;add	x[1],y[1]
		addwf	x1,1
		movlw	D'1'
		btfsc	STATUS,C
		addwf	x2,1
		btfsc	STATUS,C
		addwf	x3,1
		
		movf	y2,0		;add	x[2],y[2]
		addwf	x2,1	
		movlw	D'1'
		btfsc	STATUS,C
		addwf	x3,1
		
		movf	y3,0		;add	x[3],y[3]
		addwf	x3,1	
		return
;---------------------------------------------------------------------
;	RQrbgoCiPOiϊ
;
;	valɂRQrbgf[^uBival[3]:val[2]:val[1]:va[0])
;
;	dcmainR[B
;
;	decɓi[B
;		(dec[0]:dec[1]:...:dec[8]:dec[9])
;		dec[0]ŏʌdec[9]ŉʌłB
;
;	ϊval͔j󂳂B
;
;	sample:
;		val	= 00:00:04:D2 h
;		dec	= 00:00:00:00:00:00:01:02:03:04
;                  dec(0):dec(1):(2):(3):(4):(5):(6):(7):(8):dec(9)
;						(1,234)
;
dcmain
		movlw	dec9		;mov	fsr,#dec_top		; i[ꏊl
		movwf	FSR
		incf	FSR,1		
		call	devide			; ŉʕϊ 
		call	devide			;10JԂ
		call	devide
		call	devide
		call	devide

		call	devide
		call	devide
		call	devide
		call	devide
		call	devide			; ŏʕϊ
		return
;
;		POTu[`
;		POŏZ܂
;
devide	movlw	D'32'
		movwf	cn			; RQrbgԂ
		
		clrf	val_m
devide0		
		bcf  	STATUS,C
		rlf  	val0,1
		rlf  	val1,1
		rlf  	val2,1
		rlf  	val3,1
		rlf  	val_m,1
		
		movlw	B'11110110'
		addwf	val_m,0
		btfsc	STATUS,C
		movwf	val_m
		btfsc	STATUS,C
		incf	val0,1

		decfsz	cn,1
		goto	devide0
		
		decf	FSR,1
		movf	val_m,0
		movwf	INDF		; ]
		return

;----------------------------------------end of 10iϊ
;-----------------------------------------------------------------------
;	|Z		x[32bit]=y[24bit] * N[8bit]
;
;	y24rbgf[^uB
;		iy[3]:y[2]:y[1]:y[0]) 
;       N 8ޯްuB
;                 N ;  ő  #255łB
;
;	xɓi[B
;                ix[3]:x[2]:x[1]:x[0]) 
;       		
;	ϊ N ͔j󂳂ȂB
;
;
mult_vN		clrf	x3
		clrf	x2
		clrf	x1
		clrf	x0
			
		movlw	D'8' 	
		movwf	cn
mult0		
		btfss	N,0
		goto	mutpas
		
		movf	y0,0		;add	x[0],y[0]
		addwf	x0,1
		movlw	D'1'
		btfsc	STATUS,C
		addwf	x1,1
		btfsc	STATUS,C
		addwf	x2,1
		btfsc	STATUS,C	
		addwf	x3,1
		
		movf	y1,0		;add	x[1],y[1]
		addwf	x1,1
		movlw	D'1'
		btfsc	STATUS,C
		addwf	x2,1
		btfsc	STATUS,C
		addwf	x3,1
		
		movf	y2,0		;add	x[2],y[2]
		addwf	x2,1	
		movlw	D'1'
		btfsc	STATUS,C
		addwf	x3,1
		
		movf	y3,0		;add	x[3],y[3]
		addwf	x3,1	
		
mutpas		bcf  	STATUS,C
		rlf  	y0,1
		rlf  	y1,1
		rlf 	y2,1
		rlf  	y3,1
		btfsc	STATUS,C	
		bsf  	y0,0

		bcf  	STATUS,C
		rrf  	N,1
		btfsc	STATUS,C
		bsf  	N,7

		decfsz	cn,1		;djnz	cn,mult0
		goto	mult0

		movlw	D'8'
		movwf	cn
multrot		bcf 	STATUS,C
		rrf  	y3,1
		rrf  	y2,1
		rrf  	y1,1
		rrf  	y0,1
		btfsc	STATUS,C
		bsf  	y3,7

		decfsz	cn,1		
		goto	multrot
		return
;---------------------------end of |Z
;------------------------------------------------
; initialize eeprom locations

		ORG	0x2100
		DE	0x00, 0x01, 0x02, 0x03


		END                      



